<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Trabajo practico N°6 de JS</title>
    <link rel="stylesheet" href="css/style.css">
</head>
<body>
<h2> 1) Que versiones de JavaScript hay en el mercado?</h2>
<p> Las versiones son:
    <ul>
    <li> JavaScript 1.0 </li>
    <li> JavaScript 1.1 </li>
    <li> JavaScript 1.2 </li>
    <li> JavaScript 1.3 </li>
    <li> JavaScript 1.4 </li>
    <li> JavaScript 1.5 </li>
    <li> JavaScript 1.6 </li>
    <li> JavaScript 1.7 </li>
</ul></p>

<h2>2) Como se integra JavaScript a HTML?</h2>
<p>Hay 3 formas de llamar al Js en HTML:</p>
<p> a) Por archivo externo: en la etiqueta head se escribe la etiqueta  script src="js/cript.js"- script  </p> 
<p> b) Por Body: se hace con la etiqueta  script console.log ("mostrando") script  </p>
<p> c) Por Script: se pone directamente la etiqueta dentro del Head script console.log ("mostrando") script  </p>

<h2>3) Como es el manejo de las variables, tipos de datos y expresiones regulares en JS? </h2>
<p> Un identificador de JavaScript debe comenzar con una letra, un guión bajo ( _ ) o un signo de dólar ( $ ). Las variables se pueden declarar 
    usando var , const o let .</p>
<p> var tiene alcance de función, mientras que const y let tienen alcance de bloque. 
    Las variables const no pueden ser reasignadas, mientras que las variables let si pueden serlo.</p>
<p> En Javascript existen 7 tipos de datos: </p>
<p> <ol>
    <li> String Cadenas de texto. </li>
    <li> Number Valores numéricos. </li>
    <li> Boolean Representa una entidad lógica y puede tener dos valores: true y false. </li>
    <li> null Es un valor asignado tiene el valor de “no valor”. </li>
    <li> undefined Una variable a la que no se le ha asignado ningún valor tiene el valor undefined. </li>
    <li> Symbol es un tipo de datos cuyos valores son únicos e inmutables. </li>
    <li> Object Un valor en memoria al que podemos acceder por un identificador. </li>
</ol> </p>
<p> Estos datos se dividen en dos grupos, Primitivos y de Objeto. </p>
<p> Los tipos primitivos no tienen métodos ni propiedades, aunque en los string, numbers y booleans podemos acceder a ellas grácias a los
     wrappers objects. Los valores primitivos son inmutables, no pueden ser cambiados. String, Number, Boolean, null, undefined y Symbol son
      tipos primitivos.</p>
<p> En JavaScript los objetos pueden ser vistos como una colección de propiedades y pueden verse así: </p>
<p> var persona = { nombre: "Marcel", edad: "38", ciudad: "Alaior" }; </p>
<p> El operador typeof devuelve una cadena indicando el tipo de valor de una variable. </p>
<p> Definamos unas variables: </p>
<p>  var mascota = "Gato"; </p>
<p>  var hermanas = 3; </p>
<p> var tv = false;</p>
<p> Veamos el operador typeof en acción: </p>
<p> console.log(typeof mascota); // "string" </p>
<p> console.log(typeof hermanas); // "number" </p>
<p> console.log(typeof tv); // "boolean" </p>
<p> Las expresiones regulares son patrones utilizados para encontrar una determinada combinación de caracteres dentro de una cadena 
    de texto. Estos tambien son objetos. </p>
<p> Estos se utilizan para:
    <ul>
        <li> Búscar y reemplazar un patrón en una cadena. </li>
        <li> Validar los campos en un formulario. </li>
    </ul>
</p>

<h2>4) Como son todas la formas de declaracion de funciones de JS?</h2>
<p> Hay tres formas de declarar las funciones en JavaScript </p>
<p> 1) Por declaracion </p>
<p> Consiste en declarar la función con un nombre y sus parámetros de entrada entre paréntesis.</p>
<p> function add(a, b){ return a+b;};add(5,6); //11 </p>
<p> 2) Por expresion </p>
<p> Consiste en guardar una función en una variable, para ejecutar la variable como si fuera una función.</p>
<p> const plus = function (a, b){ return a+b;};plus(5,6); //11 </p>
<p> 3) Por constructor de objetos</p>
<p> Consiste unicamente para recordar que las funciones tambien son tipo de objeto </p>
<p> const greetings = new Function("return 'Hola';");greetings (); // 'Hola' </p>

<h2>5) Cuales son los operadores y conversion entre tipos?</h2>
<p> Los operadores son: 
    <ul>
        <li> Operador asignacion </li>
        <li> Operador aritmetico </li>
        <li> Operador aritmetico incrementable </li>
        <li> Operador aritmetico combinado </li>
        <li> Operador de relacion </li>
        <li> Operador logico o booleano </li>
        <li> Operador condicional </li>
        <li> Operador de bit </li>
        <li> Operador concatenacion de cadenas </li>
    </ul>
</p>
<p> Conversiones entre tipo hace referencia a cuando una funcion cambia automaticamente el valor que se le pasa por otro correcto. </p>
<p> Por ejemplo, alert convierte automaticamente cualquier valor a string para mostrarlo. Los operaciones matematicas convierte los valores a numeros. </p>
<h2>6) Cuales son las estructuras de control de JS?</h2>
<p> Las estructuras son: </p>
<p> <ol>
    <li> Estructa de control if/else: 
        <p> if (condicion) {</p>
        <p> instrucciones que se ejecutarán si se cumple la condición</p>
        <p> }else{ </p>
        <p> instrucciones que se ejecutarán si NO se cumple la condición </p>
        <p> }</p>
    </li>
    <li> Estructura de control while: 
        <p> switch (expresion){ </p>
        <p> case valor1: sentencia1; </p>
        <p> break; </p>
        <p> case valor2: sentencia2; </p>
        <p> break; </p>
        <p> case valorN: sentenciaN; </p>
        <p> break; </p>
        <p> default: sentenciaFinal; </p>
        <p> break;</p>
        <p> } </p>
    </li>
    <li> Estructura de control for:
        <p> for (inicio; test; incremento){ </p>
        <p> sentencia </p>
        <p> } </p>
    </li>
</ol></p>

<h2>7) Que es el objeto dom de JS? Y como trabaja? </h2>
<p> DOM (Document Object Model) es una interfaz de programación que nos permite crear, cambiar o remover elementos de documentos HTML y XML.
    Facilita una representación estructurada del documento y define de qué manera los programas pueden 
    acceder, al fin de modificar, tanto su estructura, estilo y contenido </p>

<h2>8) Que funcion tiene en JS el Object Map? </h2>
<p> El método map() crea un nuevo array con los resultados de la llamada a la función indicada aplicados a cada uno de sus elementos. </p>
<p> El método Array.map() se utiliza para hacer cambios a los elementos, ya sea multiplicando por un número específico como en el código anterior,
     o haciendo cualquier otra operación que pueda necesitar para su aplicación. </p>
     
<h2>9) Cuales son todos los eventos que trabaja JS?</h2>
<p> <ul>
    <li> onblur : Un elemento pierde el foco. 
        <p> Elementos para los que esta definido son: button, input, label, select, textarea, body. </p></li>
    <li> onchange : Un elemento ha sido modificado. 
        <p> Elementos para los que esta definido son: input, select, textarea. </p></li>
    <li> onclick : Pulsar y soltar el raton. 
        <p> Elementos para los que esta definido son: Todos los elementos. </p></li>
    <li> ondblclick : Pulsa dos veces seguidas con el raton.
         <p> Elementos para los que esta definido son: Todos los elementos. </p></li>
    <li> onfocus : Un elemento obtiene el foco. 
        <p> Elementos para los que esta definido son: button, input, label, select, textarea, body. </p></li>
    <li> onkeydow : Pulsar una tecla y no soltarla.
        <p> Elementos para los que esta definido son: Elementos de formulario y body. </p></li>
    <li> onkeypress : Pulsar una tecla. 
        <p> Elementos para los que esta definido son: Elementos de formulario y body. </p></li>
    <li> onkeyup : Soltar una tecla pulsada. 
        <p> Elementos para los que esta definido son: Elementos de formulario y body. </p></li>
    <li> onload : Pagina cargada completamente. 
        <p> Elementos para los que esta definido son: body. </p></li>
    <li> onmousedown : Pulsar un boton del raton y no sorltarlo. 
        <p> Elementos para los que esta definido son: Todos los elementos. </p></li>
    <li> onmousemove : Mover el raton. 
        <p> Elementos para los que esta definido son: Todos los elementos. </p></li>
    <li> onmouseout : El raton "sale" del elemento. 
        <p> Elementos para los que esta definido son: Todos los elementos. </p></li>
    <li> onmouseover : El raton "entra" en el elemento. 
        <p> Elementos para los que esta definido son: Todos los elementos. </p></li>
    <li> onmouseup : Soltar el boton del raton. 
        <p> Elementos para los que esta definido son: Todos los elementos. </p></li>
    <li> onreset : Inicializar el formulario. 
        <p> Elementos para los que esta definido son: form. </p></li>
    <li> onresize : Modificar el tamaño de la ventana. 
        <p> Elementos para los que esta definido son: body. </p></li>
    <li> onselect : Seleccionar un texto. 
        <p> Elementos para los que esta definido son: input, textarea. </p></li>
    <li> onsubmit : Enviar el formulario. 
        <p> Elementos para los que esta definido son: form. </p></li>
    <li> onunload : Se abandona la pagina, por ejemplo, al cerrar el navegador. 
        <p> Elementos para los que esta definido son: body. </p></li>
</ul></p>

<h2>10) Con toda la investigacion que generaron deben generar un formulario que realice las siguientes funciones.</h2>
<p></p>
<h3>a) Que obtenga los datos del input </h3>
<h3>b) Que verifique los datos que se ingresan en el input</h3>
<h3>c) Que el formulario precente un calculo de sumatoria para validar que "Que no sos un robot"</h3>
<p></p>
</body>
</html>